SystemOrganization addCategory: #'PostMark-Core'!

Object subclass: #PMInterface
	instanceVariableNames: 'apiKey apiUrl debugStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostMark-Core'!

!PMInterface commentStamp: 'FrancoisStephany 12/15/2011 18:59' prior: 0!
| email interface |
email := PMEmail new
	from: 'francois@wapict.be'
	to: 'francois@yopmail.com';
	subject: 'Test Application';
	textBody: 'Yeah baby';
	yourself.

interface := PMInterface new.


interface send: email.!

!PMInterface methodsFor: 'accessing' stamp: 'FrancoisStephany 12/15/2011 17:38'!
apiKey
	^ apiKey ifNil: [ apiKey := self defaultApiKey ]! !

!PMInterface methodsFor: 'accessing' stamp: 'FrancoisStephany 12/15/2011 17:22'!
apiKey: aByteString 
	apiKey := aByteString! !

!PMInterface methodsFor: 'accessing' stamp: 'FrancoisStephany 12/15/2011 17:39'!
apiUrl
	^apiUrl ifNil: [ apiUrl  := self defaultApiUrl ].! !

!PMInterface methodsFor: 'private' stamp: 'FrancoisStephany 12/15/2011 18:12'!
buildZnClientForContent: aString
	| body |
	body := ZnEntity 
		with: aString
		type: ZnMimeType applicationJson.

	^ZnClient new
		headerAt: 'X-Postmark-Server-Token' put: self apiKey;
		url: self apiUrl;
		entity: body.! !

!PMInterface methodsFor: 'accessing' stamp: 'FrancoisStephany 12/15/2011 18:14'!
debugStream
	^ debugStream! !

!PMInterface methodsFor: 'accessing' stamp: 'FrancoisStephany 12/15/2011 18:28'!
debugStream: aStream
	debugStream := aStream! !

!PMInterface methodsFor: 'default values' stamp: 'FrancoisStephany 12/15/2011 17:40'!
defaultApiKey
	"put the API in Test mode by default."
	^ 'POSTMARK_API_TEST'! !

!PMInterface methodsFor: 'default values' stamp: 'FrancoisStephany 12/15/2011 18:42'!
defaultApiUrl
	^'http://api.postmarkapp.com/email'! !

!PMInterface methodsFor: 'testing' stamp: 'FrancoisStephany 12/15/2011 18:14'!
developmentMode
	^debugStream isNil not.! !

!PMInterface methodsFor: 'private' stamp: 'FrancoisStephany 12/15/2011 18:55'!
handleError: aZnResponse
	aZnResponse isAuthenticationRequired
		ifTrue: [ ^PMException signal: 'Incorrect API Key.' ] .
	aZnResponse status =  422
		ifTrue: [ ^self processIncorrectFields: aZnResponse contents].
		
	PMException signal: 'Unkown error: ' , aZnResponse status printString.! !

!PMInterface methodsFor: 'private' stamp: 'FrancoisStephany 12/15/2011 18:54'!
handleResponse: aZnResponse
	aZnResponse isSuccess ifTrue: [ ^true ].
	
	self handleError: aZnResponse.
	^false! !

!PMInterface methodsFor: 'private' stamp: 'FrancoisStephany 12/15/2011 18:53'!
processIncorrectFields: aString
	| json |
	json := Json readFrom: aString readStream.
	PMException signal: 'Error : ' , (json at: 'ErrorCode') printString , ' - ' , (json at: 'Message').! !

!PMInterface methodsFor: 'public API' stamp: 'FrancoisStephany 12/15/2011 18:43'!
send: email
	| client |
	self developmentMode
		ifTrue: [ ^self simulateSendOf: email ].
	client := self buildZnClientForContent: (Json render: email).
	client post.
	
	^self handleResponse: client response.! !

!PMInterface methodsFor: 'private' stamp: 'FrancoisStephany 12/20/2011 15:06'!
simulateSendOf: aPMEmail
	aPMEmail jsonWriteOn: self debugStream.
	self debugStream flush.! !

Error subclass: #PMException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostMark-Core'!

!PMException commentStamp: 'FrancoisStephany 12/15/2011 19:01' prior: 0!
I'm thrown when an error is encountered within PostMark.
See http://developer.postmarkapp.com/developer-build.html for more details about the errors that could occur during a transaction.!

JsonObject subclass: #PMEmail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostMark-Core'!

!PMEmail commentStamp: 'FrancoisStephany 12/15/2011 19:00' prior: 0!
See PMInterface comment for an overview.

I act like a Dictionary. According to PostMark documentation, I accept the following values:

{
  "From" : "sender@example.com",
  "To" : "receiver@example.com",
  "Cc" : "copied@example.com",
  "Bcc": "blank-copied@example.com",
  "Subject" : "Test",
  "Tag" : "Invitation",
  "HtmlBody" : "<b>Hello</b>",
  "TextBody" : "Hello",
  "ReplyTo" : "reply@example.com",
  "Headers" : [{ "Name" : "CUSTOM-HEADER", "Value" : "value" }]
}!
